# movie2.tcl

# A Vis5d Tcl script for saving a whole time series of images
# with multiple data sets.

# You may need to change these:
set base "frame"
set ext ".ppm"
set format VIS5D_PPM
set ctx0 0
set ctx1 1
set dtx0 0
set dtx1 1
set grp 1

vis5d_set_display_matrix 1 2

vis5d_set_display_group 0 1
vis5d_set_display_group 1 1
set numtimes [ vis5d_get_grp_numtimes $grp ]

vis5d_graphics_mode 0 VIS5D_MAP VIS5D_ON
vis5d_graphics_mode 0 VIS5D_TOPO VIS5D_ON
vis5d_enable_graphics 0 VIS5D_CHSLICE 0 VIS5D_ON
vis5d_make_chslice 0  VIS5D_ALL_TIMES 0 1
vis5d_enable_graphics 0  VIS5D_HSLICE 0 VIS5D_ON
vis5d_make_hslice 0  VIS5D_ALL_TIMES 0 1

vis5d_graphics_mode 1 VIS5D_MAP VIS5D_ON
vis5d_graphics_mode 1 VIS5D_TOPO VIS5D_ON
vis5d_enable_graphics 1 VIS5D_CHSLICE 0 VIS5D_ON
vis5d_make_chslice 1  VIS5D_ALL_TIMES 0 1
vis5d_enable_graphics 1 VIS5D_HSLICE 0 VIS5D_ON
vis5d_make_hslice 1  VIS5D_ALL_TIMES 0 1

for {set time 1} {$time<=$numtimes} {set time [expr $time+1]} {
	vis5d_set_grp_timestep $grp [expr $time-1]
	vis5d_draw_frame $dtx0
        vis5d_draw_frame $dtx1
	set name $base$time$ext
	vis5d_save_window $name $format
}


# At this point you may want to invoke a Unix utility to convert a
# series of GIF files into an MPEG animation file.....
