/* read_grid.h */
/* Vis5D version 5.1 */

/*
Vis5D system for visualizing five dimensional gridded data sets
Copyright (C) 1990 - 1997 Bill Hibbard, Johan Kellum, Brian Paul,
Dave Santek, and Andre Battaiola.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


/*
 * Functions for reading with McIDAS GRID files
 */


#ifndef READ_GRID_H
#define READ_GRID_H


#include "grid_i.h"



/*
 * Get a description of the contents of a McIDAS GRID file.
 */
extern int get_grid_info( char *name, struct grid_db *db );


/*
 * Get actual grid data.
 */
extern float *get_grid_data( struct grid_info *g );



#endif
